function I = nanagglo_I(I_i, t_i, t, eps_dt)
% I = nanagglo_I(I_i, t_i, t, eps_dt)
%
% Partial sum of valid data.

if (nargin == 2)
    I = t_i*I;
    return
end

nt = length(t);
% I_i(isnan(I_i)) = 0;

nd = size(I_i,2);

I = zeros(nt,nd);


k = 1;
ind_i = find(t_i<=t(k));
I(k,:) = nansum(I_i(ind_i,:),1);

if (length(t)>=2)
    dt = t(2)-t(1);
    if (nargin < 4)
        eps_dt = dt/100;
    end
    for k = 2:nt,
        ind_i = find((t_i>t(k-1)+eps_dt)&(t_i<=t(k)+eps_dt));
        I(k,:) = nansum(I_i(ind_i,:),1);
    end
end

